<script lang="ts">
import { defineComponent } from 'vue';

export default defineComponent({
  name: 'JActionIcon',
  props: {
    tag: {
      type: [String, Object],
      default: 'div',
    },
    disable: {
      type: Boolean,
      default: false,
    },
    size: {
      type: String,
      default: 'xs',
      validator: (value: string): boolean => ['s', 'xs', 'ms'].includes(value),
    },
  },
});
</script>

<template>
  <component
    :is="tag"
    v-ripple
    tabindex="0"
    class="j-action-icon j-hover-effect"
    :class="[size, { disable }]"
  >
    <slot />
  </component>
</template>

<style scoped lang="scss">
@use '../JIcon/mixins.scss' as iconMixins;

.j-action-icon {
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
  cursor: pointer;
  border-radius: 5px;
  color: rgb(var(--j-secondary-title-color));
  overflow: hidden;

  // TODO: add to variables
  &.xs {
    width: 24px;
    height: 24px;
  }

  &.s {
    width: 30px;
    height: 30px;
  }

  &.ms {
    width: 32px;
    height: 32px;
  }

  &.disable {
    opacity: 0.4;
  }

  &:hover {
    background-color: var(--j-item-hover-bg-color);

    @include iconMixins.primary-color-on-hover;
    @include iconMixins.toggle-use-tag-by-hover-attr;
  }

  &:focus {
    background-color: var(--j-primary-light-color);

    svg {
      fill: rgb(var(--j-primary-color));
      color: rgb(var(--j-primary-color));
    }
  }

  &:focus-visible {
    outline: var(--j-focus-outline);
  }
}
</style>
